-----------------------------
-- Bunch of functions inc! --
-----------------------------
function PA_ButtonControl(Button,state)
	if(Button == "Master") then
		if(state == "Enable") then
			PA_SavedSettings["MasterChecked"] = true
			MinimapButton:Enable()
			PA_Minimap:Show()
			MillingButton:Enable()
			HerbButton:Enable()
			ProspectingButton:Enable()
			OreButton:Enable()
			EnchantingButton:Enable()
			MaterialButton:Enable()
			if(MillingButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Milling) end
			if(HerbButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Herb) end
			if(ProspectingButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Prospecting) end
			if(OreButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Ore) end
			if(EnchantingButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Enchanting) end
			if(MaterialButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Material) end
		end
		if(state == "Disable") then
			PA_SavedSettings["MasterChecked"] = false
			MinimapButton:Disable()
			PA_Minimap:Hide()
			MillingButton:Disable()
			HerbButton:Disable()
			ProspectingButton:Disable()
			OreButton:Disable()
			EnchantingButton:Disable()
			MaterialButton:Disable()
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Milling)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Herb)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Prospecting)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Ore)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Enchanting)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Material)
		end
		if(state == "Startup") then
			MinimapButton:Enable()
			MillingButton:Enable()
			HerbButton:Enable()
			ProspectingButton:Enable()
			OreButton:Enable()
			EnchantingButton:Enable()
			MaterialButton:Enable()
			if(PA_SavedSettings["MillingChecked"]) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Milling) end
			if(PA_SavedSettings["HerbChecked"]) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Herb) end
			if(PA_SavedSettings["ProspectingChecked"]) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Prospecting) end
			if(PA_SavedSettings["OreChecked"]) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Ore) end
			if(PA_SavedSettings["EnchantingChecked"]) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Enchanting) end
			if(PA_SavedSettings["MaterialChecked"]) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Material) end
		end
		if(state == "startup2") then
			MinimapButton:Disable()
			MillingButton:Disable()
			HerbButton:Disable()
			ProspectingButton:Disable()
			OreButton:Disable()
			EnchantingButton:Disable()
			MaterialButton:Disable()
			if(not PA_SavedSettings["MillingChecked"]) then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Milling) end
			if(not PA_SavedSettings["HerbChecked"]) then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Herb) end
			if(not PA_SavedSettings["ProspectingChecked"]) then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Prospecting) end
			if(not PA_SavedSettings["OreChecked"]) then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Ore) end
			if(not PA_SavedSettings["EnchantingChecked"]) then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Enchanting) end
			if(not PA_SavedSettings["MaterialChecked"]) then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Material) end
		end
	end
	if(Button == "Minimap") then
		if(state == "Enable") then PA_SavedSettings["MinimapChecked"] = true end
		if(state == "Disable") then PA_SavedSettings["MinimapChecked"] = false end
	end
	if(Button == "Milling") then
		if(state == "Enable") then
			PA_SavedSettings["MillingChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Milling)
		end
		if(state == "Disable") then
			PA_SavedSettings["MillingChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Milling)
		end
		MillingButton:SetChecked(PA_SavedSettings["MillingChecked"])
	end
	if(Button == "Herb") then
		if(state == "Enable") then
			PA_SavedSettings["HerbChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Herb)
		end
		if(state == "Disable") then
			PA_SavedSettings["HerbChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Herb)
		end
		HerbButton:SetChecked(PA_SavedSettings["HerbChecked"])
	end
	if(Button == "Prospecting") then
		if(state == "Enable") then
			PA_SavedSettings["ProspectingChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Prospecting)
		end
		if(state == "Disable") then
			PA_SavedSettings["ProspectingChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Prospecting)
		end
		ProspectingButton:SetChecked(PA_SavedSettings["ProspectingChecked"])
	end
	if(Button == "Ore") then
		if(state == "Enable") then
			PA_SavedSettings["OreChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Ore)
		end
		if(state == "Disable") then
			PA_SavedSettings["OreChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Ore)
		end
		OreButton:SetChecked(PA_SavedSettings["OreChecked"])
	end
	if(Button == "Enchanting") then
		if(state == "Enable") then
			PA_SavedSettings["EnchantingChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Enchanting)
		end
		if(state == "Disable") then
			PA_SavedSettings["EnchantingChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Enchanting)
		end
		EnchantingButton:SetChecked(PA_SavedSettings["EnchantingChecked"])
	end
	if(Button == "Material") then
		if(state == "Enable") then
			PA_SavedSettings["MaterialChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_Material)
		end
		if(state == "Disable") then
			PA_SavedSettings["MaterialChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_Material)
		end
		MaterialButton:SetChecked(PA_SavedSettings["MaterialChecked"])
	end
end
--------------------------
-- Button creator stuff --
--------------------------
local function createCheckbutton(parent, x_loc, y_loc, IDname, displayname, description)
	local checkbutton = CreateFrame("CheckButton", "PA_interface_checkbutton_" .. IDname, parent, "InterfaceOptionsCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	checkbutton.tooltipText = displayname;
	checkbutton.tooltipRequirement = description;
	
	return checkbutton;
end

----------------------------
-- FontText creator stuff --
----------------------------
local function createFonttext(parent, x_loc, y_loc, text, fonttemplate)
	local title = parent:CreateFontString(nil, "ARTWORK", fonttemplate);
	title:SetPoint("TOPLEFT", x_loc, y_loc)
	title:SetText(text)
end

--------------------------------
-- DropDownMenu creator stuff --
--------------------------------
function PA_CreateMenu(parent, x_loc, y_loc, IDname, displayname, description)
	local menu = CreateFrame("Button", "PA_interface_dropdownmenu_" .. IDname, parent, "UIDropDownMenuTemplate")
	
	menu:SetPoint("TOPLEFT", x_loc, y_loc)
	menu:Show()
	
	local function OnClick(self)
		if(menu == PA_interface_dropdownmenu_Milling) then
			PA_SavedSettings["MillingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			MillingID = self:GetID();
		end
		if(menu == PA_interface_dropdownmenu_Herb) then
			PA_SavedSettings["HerbKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			HerbID = self:GetID();
		end
		if(menu == PA_interface_dropdownmenu_Prospecting) then
			PA_SavedSettings["ProspectingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			ProspectingID = self:GetID();
		end
		if(menu == PA_interface_dropdownmenu_Ore) then
			PA_SavedSettings["OreKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			OreID = self:GetID();
		end
		if(menu == PA_interface_dropdownmenu_Enchanting) then
			PA_SavedSettings["EnchantingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			EnchantingID = self:GetID();
		end
		if(menu == PA_interface_dropdownmenu_Material) then
			PA_SavedSettings["MaterialKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			MaterialID = self:GetID();
		end
	end
	
	local function init(self, level)
		for _,v in next, {
			"Always",
			"Shift",
			"Ctrl",
			"Alt"
		}do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end
	
	menu:SetScript('OnEnter', function(self)
		GameTooltip:SetOwner(self,"ANCHOR_TOPRIGHT")
		GameTooltip:SetText(displayname, nil, nil, nil, 1, 1)
		GameTooltip:AddLine(description, 1, 1, 1)
		GameTooltip:Show()
	end)
	menu:SetScript('OnLeave', function(self) GameTooltip:Hide() end)
	
	UIDropDownMenu_Initialize(menu, init)
	UIDropDownMenu_SetWidth(menu, 75);
	UIDropDownMenu_SetButtonWidth(menu, 50)
	UIDropDownMenu_JustifyText(menu, "LEFT")
end

-------------------
-- Minimap stuff --
-------------------
function PA_Minimap_Init(parent)
	local menu = CreateFrame("Frame", "PA_Minimap_Menu", parent, "UIDropDownMenuTemplate")
	
	local icons = {
		"", -- space holder
		"Interface\\ICONS\\Ability_miling",
		"Interface\\ICONS\\Trade_herbalism",
		"Interface\\ICONS\\Inv_misc_gem_bloodgem_01",
		"Interface\\ICONS\\Trade_mining",
		"Interface\\ICONS\\Trade_Engraving",
		"Interface\\ICONS\\INV_Enchant_Disenchant"
	}
	
	local function OnClick(self, arg1, _, checked) if not(arg1==Close) and (checked) then PA_ButtonControl(arg1,"Enable") else PA_ButtonControl(arg1,"Disable") end end
	
	local function init(self, level)
		info = UIDropDownMenu_CreateInfo()
		for k,v in next, {
			"Toggle options",
			"Milling",
			"Herb",
			"Prospecting",
			"Ore",
			"Enchanting",
			"Material",
			"Close"
		}do
			if(v=="Toggle options") then
				info.text = v;
				info.isTitle = true;
				info.notCheckable = true;
				UIDropDownMenu_AddButton(info, level)
			else
				if(v=="Close") then
					info.text = v
					info.func = OnClick
					info.arg1 = v
					info.icon = nil
					info.notCheckable = true;
					info.keepShownOnClick = false;
					UIDropDownMenu_AddButton(info, level)
				else
					info.text = v.." results"
					info.func = OnClick
					info.arg1 = v
					info.icon = icons[k]
					info.checked = PA_SavedSettings[v.."Checked"];
					info.isTitle = false;
					info.disabled = false;
					info.isNotRadio = true;
					info.notCheckable = false;
					info.keepShownOnClick = true;
					UIDropDownMenu_AddButton(info, level)
				end
			end
		end
	end
	UIDropDownMenu_Initialize(menu, init, "MENU")
end

local function moveButton(self)
	local centerX, centerY = Minimap:GetCenter()
	local x, y = GetCursorPosition()
	x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
	centerX, centerY = math.abs(x), math.abs(y)
	centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 80, (centerY / sqrt(centerX^2 + centerY^2)) * 80
	centerX = x < 0 and -centerX or centerX
	centerY = y < 0 and -centerY or centerY
	self:ClearAllPoints()
	self:SetPoint("CENTER", centerX, centerY)
	PA_SavedSettings["Minimap_PosX"] = centerX
	PA_SavedSettings["Minimap_PosY"] = centerY
end
local function PA_Minimap_Create()
	PA_Minimap = CreateFrame("Button", "Profession Assistance", Minimap)
	PA_Minimap:SetSize(31, 31)
	PA_Minimap:SetFrameStrata("MEDIUM")
	PA_Minimap:SetPoint("CENTER", PA_SavedSettings["Minimap_PosX"], PA_SavedSettings["Minimap_PosY"])
	PA_Minimap:SetMovable(true)
	PA_Minimap:SetUserPlaced(true)
	PA_Minimap:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
	
	local overlay = PA_Minimap:CreateTexture(nil, "OVERLAY")
	overlay:SetSize(53, 53)
	overlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	overlay:SetPoint("TOPLEFT")
	
	local icon = PA_Minimap:CreateTexture(nil, "ARTWORK")
	icon:SetSize(18.5, 18.5)
	icon:SetTexture("Interface\\ICONS\\INV_Hammer_20")
	icon:SetPoint("TOPLEFT", 7, -5.5)
	
	PA_Minimap:RegisterForClicks("AnyDown")
	PA_Minimap:SetScript("OnClick", function(self, button, down)
		if button == "LeftButton" then
			icon:SetPoint("TOPLEFT", 7, -5.5)
			icon:SetSize(18,18)
			ToggleDropDownMenu(1, nil, PA_Minimap_Menu, self, 0, 0);
		else
			if IsShiftKeyDown() then
				icon:SetPoint("TOPLEFT", 7, -5.5)
				icon:SetSize(18,18)
				self:SetScript("OnUpdate", moveButton)
			else
				icon:SetPoint("TOPLEFT", 7, -5.5)
				icon:SetSize(18,18)
				InterfaceOptionsFrame_OpenToCategory("Profession Assistance")
				InterfaceOptionsFrame_OpenToCategory("Profession Assistance")
			end
		end
	end)
	PA_Minimap:SetScript("OnMouseUp", function(self)
		self:SetScript("OnUpdate", nil)
		icon:SetSize(18.5,18.5)
		icon:SetPoint("TOPLEFT", 7, -5.5)
	end)
	
	PA_Minimap:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_BOTTOMLEFT")
		GameTooltip:SetText("Profession Assistance", nil, nil, nil, 1, 1)
		GameTooltip:AddLine(" ")
		GameTooltip:AddLine("|cff00ff00Left-click|r to open sub-menu.", 1, 1, 1)
		GameTooltip:AddLine("|cff00ff00Right-click|r to open interface panel.", 1, 1, 1)
		GameTooltip:AddLine("|cff00ff00Shift+Right-click|r to drag this icon.", 1, 1, 1)
		GameTooltip:Show()
	end)
	PA_Minimap:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	if(MinimapButton:IsEnabled() and MinimapButton:GetChecked()) then PA_Minimap:Show() else PA_Minimap:Hide() end
	MinimapButton:SetScript("OnClick", function()
		if(MinimapButton:GetChecked()) then
			PA_ButtonControl("Minimap","Enable")
			PA_Minimap:Show()
		else
			PA_ButtonControl("Minimap","Disable")
			PA_Minimap:Hide()
		end
	end);
	
	PA_Minimap_Init(PA_Minimap)
end

--------------------------
-- Interface AddOns tab --
--------------------------
local LoadFrame = CreateFrame("Frame")
LoadFrame:RegisterEvent("PLAYER_LOGIN");
LoadFrame:SetScript("OnEvent", function(self,event,...)
	UIParent:HookScript("OnEvent", function(s, e, a1, a2) if e:find("ACTION_FORBIDDEN") and ((a1 or "")..(a2 or "")):find("IsDisabledByParentalControls") then StaticPopup_Hide(e) end; end)
	if(type(PA_SavedSettings) ~= "table") then PA_SavedSettings = {} end
	
	if(PA_SavedSettings["MasterChecked"] == nil) then PA_SavedSettings["MasterChecked"] = true
	else PA_SavedSettings["MasterChecked"] = PA_SavedSettings["MasterChecked"] end
	
	if(PA_SavedSettings["MinimapChecked"] == nil) then PA_SavedSettings["MinimapChecked"] = true
	else PA_SavedSettings["MinimapChecked"] = PA_SavedSettings["MinimapChecked"] end
	
	if(PA_SavedSettings["Minimap_PosX"] == nil) then PA_SavedSettings["Minimap_PosX"] = -78.5
	else PA_SavedSettings["Minimap_PosX"] = PA_SavedSettings["Minimap_PosX"] end
	
	if(PA_SavedSettings["Minimap_PosY"] == nil) then PA_SavedSettings["Minimap_PosY"] = -16
	else PA_SavedSettings["Minimap_PosY"] = PA_SavedSettings["Minimap_PosY"] end
	
	if(PA_SavedSettings["MillingChecked"] == nil) then PA_SavedSettings["MillingChecked"] = true
	else PA_SavedSettings["MillingChecked"] = PA_SavedSettings["MillingChecked"] end
	
	if(PA_SavedSettings["HerbChecked"] == nil) then PA_SavedSettings["HerbChecked"] = true
	else PA_SavedSettings["HerbChecked"] = PA_SavedSettings["HerbChecked"] end
	
	if(PA_SavedSettings["ProspectingChecked"] == nil) then PA_SavedSettings["ProspectingChecked"] = true
	else PA_SavedSettings["ProspectingChecked"] = PA_SavedSettings["ProspectingChecked"] end
	
	if(PA_SavedSettings["OreChecked"] == nil) then PA_SavedSettings["OreChecked"] = true
	else PA_SavedSettings["OreChecked"] = PA_SavedSettings["OreChecked"] end
	
	if(PA_SavedSettings["EnchantingChecked"] == nil) then PA_SavedSettings["EnchantingChecked"] = true
	else PA_SavedSettings["EnchantingChecked"] = PA_SavedSettings["EnchantingChecked"] end
	
	if(PA_SavedSettings["MaterialChecked"] == nil) then PA_SavedSettings["MaterialChecked"] = true
	else PA_SavedSettings["MaterialChecked"] = PA_SavedSettings["MaterialChecked"] end
	
	if(PA_SavedSettings["MillingKey"] == nil) then PA_SavedSettings["MillingKey"] = 1
	else PA_SavedSettings["MillingKey"] = PA_SavedSettings["MillingKey"] end
	
	if(PA_SavedSettings["HerbKey"] == nil) then PA_SavedSettings["HerbKey"] = 1
	else PA_SavedSettings["HerbKey"] = PA_SavedSettings["HerbKey"] end
	
	if(PA_SavedSettings["ProspectingKey"] == nil) then PA_SavedSettings["ProspectingKey"] = 1
	else PA_SavedSettings["ProspectingKey"] = PA_SavedSettings["ProspectingKey"] end
	
	if(PA_SavedSettings["OreKey"] == nil) then PA_SavedSettings["OreKey"] = 1
	else PA_SavedSettings["OreKey"] = PA_SavedSettings["OreKey"] end
	
	if(PA_SavedSettings["EnchantingKey"] == nil) then PA_SavedSettings["EnchantingKey"] = 1
	else PA_SavedSettings["EnchantingKey"] = PA_SavedSettings["EnchantingKey"] end
	
	if(PA_SavedSettings["MaterialKey"] == nil) then PA_SavedSettings["MaterialKey"] = 1
	else PA_SavedSettings["MaterialKey"] = PA_SavedSettings["MaterialKey"] end
	
	PA_Panel = {};
	
	-- Main panel
	PA_Panel.Main = CreateFrame( "Frame", "MainPanel", UIParent );
	PA_Panel.Main.name = "Profession Assistance";
	
	-- title
	--createFonttext(Parent, Positionx, Positiony, text, template)
	createFonttext(PA_Panel.Main, 15, -15, "Profession Assistance", "GameFontNormalLarge")
	
	-- content
	createFonttext(PA_Panel.Main, 20, -80, "|cffffcc00Version|r     "..GetAddOnMetadata("Profession_Assistance","Version"), "GameFontHighlight")
	createFonttext(PA_Panel.Main, 20, -95, "|cffffcc00Notes|r       "..GetAddOnMetadata("Profession_Assistance","Notes"), "GameFontHighlight")
	createFonttext(PA_Panel.Main, 20, -125, "|cffffcc00Author|r     "..GetAddOnMetadata("Profession_Assistance","Author"), "GameFontHighlight")
	createFonttext(PA_Panel.Main, 20, -140, "|cffffcc00Credits|r     "..GetAddOnMetadata("Profession_Assistance","X-Credits"), "GameFontHighlight")
	
	InterfaceOptions_AddCategory(PA_Panel.Main);
	
	-- Options panel
	PA_Panel.Options = CreateFrame( "Frame", "OptionsPanel", PA_Panel.Main);
	PA_Panel.Options.name = "Options";
	
	-- title
	createFonttext(PA_Panel.Options, 15, -15, "Options", "GameFontNormalLarge")
	
	-- global
	createFonttext(PA_Panel.Options, 20, -60, "|cffffcc00Global|r", "GameFontNormalLarge")
	-- createCheckbutton(Parent, Positionx, positiony, label, description);
	MasterButton = createCheckbutton(PA_Panel.Options, 15, -80, "Master", "Enabled", "Master switch");
	MasterButton:SetChecked(PA_SavedSettings["MasterChecked"])
	
	-- Minimap
	createFonttext(PA_Panel.Options, 20, -140, "|cffffcc00Minimap Button|r", "GameFontNormalLarge")
	-- createCheckbutton(Parent, Positionx, positiony, label, description);
	MinimapButton = createCheckbutton(PA_Panel.Options, 15, -160, "Minimap", "Enabled", "Toggle minimap button");
	MinimapButton:SetChecked(PA_SavedSettings["MinimapChecked"])
	
	-- Milling
	createFonttext(PA_Panel.Options, 320, -60, "|cffffcc00Milling|r", "GameFontNormalLarge")	
	MillingButton = createCheckbutton(PA_Panel.Options, 315, -80, "Milling", "Enable Milling", "Toggle milling information on herbs");
	MillingButton:SetChecked(PA_SavedSettings["MillingChecked"])
	
	createFonttext(PA_Panel.Options, 320, -115, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 305, -130, "Milling", "Appearance control: ","Select one option to make it appear on keyhold or just always");
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_Milling, PA_SavedSettings["MillingKey"])
	
	HerbButton = createCheckbutton(PA_Panel.Options, 315, -170, "Herb", "Enable Herb", "Toggle herb information on pigments");
	HerbButton:SetChecked(PA_SavedSettings["HerbChecked"])
	
	createFonttext(PA_Panel.Options, 320, -205, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 305, -220, "Herb", "Appearance control: ","Select one option to make it appear on keyhold or just always");
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_Herb, PA_SavedSettings["HerbKey"])
	
	-- Prospecting
	createFonttext(PA_Panel.Options, 20, -280, "|cffffcc00Prospecting|r", "GameFontNormalLarge")
	ProspectingButton = createCheckbutton(PA_Panel.Options, 15, -300, "Prospecting", "Enable Prospecting", "Toggle prospecting information on ores");
	ProspectingButton:SetChecked(PA_SavedSettings["ProspectingChecked"])
	
	createFonttext(PA_Panel.Options, 20, -335, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 5, -350, "Prospecting", "Appearance control", "Select one option to make it appear on keyhold or just always")
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_Prospecting, PA_SavedSettings["ProspectingKey"])
	
	OreButton = createCheckbutton(PA_Panel.Options, 15, -390, "Ore", "Enable Ore", "Toggle ore information on gems");
	OreButton:SetChecked(PA_SavedSettings["OreChecked"])
	
	createFonttext(PA_Panel.Options, 20, -425, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 5, -445, "Ore", "Appearance control", "Select one option to make it appear on keyhold or just always")
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_Ore, PA_SavedSettings["OreKey"])
	
	-- Enchanting
	createFonttext(PA_Panel.Options, 320, -280, "|cffffcc00Enchanting|r", "GameFontNormalLarge")
	EnchantingButton = createCheckbutton(PA_Panel.Options, 315, -300, "Enchanting", "Enable Enchanting", "Toggle enchanting information on gear");
	EnchantingButton:SetChecked(PA_SavedSettings["EnchantingChecked"])
	
	createFonttext(PA_Panel.Options, 320, -335, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 305, -350, "Enchanting", "Appearance control", "Select one option to make it appear on keyhold or just always")
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_Enchanting, PA_SavedSettings["EnchantingKey"])
	
	MaterialButton = createCheckbutton(PA_Panel.Options, 315, -390, "Material", "Enable Materials", "Toggle gear source information on enchanting materials");
	MaterialButton:SetChecked(PA_SavedSettings["MaterialChecked"])
	
	createFonttext(PA_Panel.Options, 320, -425, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 305, -445, "Material", "Appearance control", "Select one option to make it appear on keyhold or just always")
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_Material, PA_SavedSettings["MaterialKey"])
	
	---------------------------
	-- Changing settings part --
	---------------------------
	-- Master button
	MasterButton:SetScript("OnClick", function() if(MasterButton:GetChecked()) then PA_ButtonControl("Master","Enable") else PA_ButtonControl("Master","Disable") end end);
	--PA_ButtonControl(ButtonName,state)
	if(PA_SavedSettings["MasterChecked"])then PA_ButtonControl("Master","startup") else PA_ButtonControl("Master","startup2") end
	
	-- Milling stuff
	MillingButton:SetScript("OnClick", function() if(MillingButton:GetChecked()) then PA_ButtonControl("Milling","Enable") else PA_ButtonControl("Milling","Disable") end end);
	MillingID = PA_SavedSettings["MillingKey"]
	
	HerbButton:SetScript("OnClick", function() if(HerbButton:GetChecked()) then PA_ButtonControl("Herb","Enable") else PA_ButtonControl("Herb","Disable") end end);
	HerbID = PA_SavedSettings["HerbKey"]
	
	-- Prospecting stuff
	ProspectingButton:SetScript("OnClick", function() if(ProspectingButton:GetChecked()) then PA_ButtonControl("Prospecting","Enable") else PA_ButtonControl("Prospecting","Disable") end end);
	ProspectingID = PA_SavedSettings["ProspectingKey"]
	
	OreButton:SetScript("OnClick", function() if(OreButton:GetChecked()) then PA_ButtonControl("Ore","Enable") else PA_ButtonControl("Ore","Disable") end end);
	OreID = PA_SavedSettings["OreKey"]
	
	-- Enchanting stuff
	EnchantingButton:SetScript("OnClick", function() if(EnchantingButton:GetChecked()) then PA_ButtonControl("Enchanting","Enable") else PA_ButtonControl("Enchanting","Disable") end end);
	EnchantingID = PA_SavedSettings["EnchantingKey"]
	
	MaterialButton:SetScript("OnClick", function() if(MaterialButton:GetChecked()) then PA_ButtonControl("Material","Enable") else PA_ButtonControl("Material","Disable") end end);
	MaterialID = PA_SavedSettings["MaterialKey"]
	
	-- Minimap button
	PA_Minimap_Create()
	
	-- Parent stuff
	PA_Panel.Options.parent = PA_Panel.Main.name;
	InterfaceOptions_AddCategory(PA_Panel.Options);
	
	-- Profile panel
	PA_Panel.Profile = CreateFrame( "Frame", "ProfileOptions", PA_Panel.Main);
	PA_Panel.Profile.name = "Profile";
	
	-- title
	createFonttext(PA_Panel.Profile, 15, -15, "Profile", "GameFontNormalLarge")
	
	-- content
	createFonttext(PA_Panel.Profile, 15, -35, "Coming soon!", "GameFontHighlight")
	
	PA_Panel.Profile.parent = PA_Panel.Main.name;
	InterfaceOptions_AddCategory(PA_Panel.Profile);
end)